#!/usr/bin/env python

from pylab import *
import numpy as np
import aov as _aov
import pyaov
from scipy.optimize import curve_fit
def acf(lag, *p):
#   print 'acf ',p[0],p[1],p[2]
   return p[0]+p[1]*np.exp(-0.5*(lag/p[2])**2)

oa=np.loadtxt('ex2a.dat',comments='!',skiprows=0)
ob=np.loadtxt('ex2b.dat',comments='!',skiprows=0)
oad=pyaov.normalize(oa[:,1],np.ones(len(oa[:,1])),var=0.)  # Subtract mean from data A
obd=pyaov.normalize(ob[:,1],np.ones(len(ob[:,1])),var=0.)  # Subtract mean from data B
lav,lmi,lmx,cc,cmi,cmx=pyaov.covar(oa[:,0],oad,oa[:,2], \
   oa[:,0],oad,oa[:,2],nct=20)       # Compute autocov. of A
pyaov.pldat(lav,cc)                  # Plot autocovariance of  A
p0 = np.array([-.15,.4,6.])
popt, pcov = curve_fit(acf, lav, cc, p0=p0)
print('fitted ACF parameters:')
for i in range(p0.size):
   print(popt[i],'+/-',np.sqrt(pcov[i,i]))
lav,lmi,lmx,cc,cmi,cmx=pyaov.covar(ob[:,0],obd,ob[:,2], \
   ob[:,0],obd,ob[:,2],nct=20)       # Compute autocov. of B
pyaov.pldat(lav,cc)                        # Plot autocovariance of  B 
lav,lmi,lmx,cc,cmi,cmx=pyaov.covar(oa[:,0],oad,oa[:,2], \
   ob[:,0],obd,ob[:,2],nct=20)       # Compute crosscov. of A and B
pyaov.pldat(lav,cc)                        # Plot cross-covariance 

